Package org.eclipse.m2m.atl.emftvm.trace.impl

# Class TracedRuleImpl

java.lang.Object
org.eclipse.emf.common.notify.impl.BasicNotifierImpl
org.eclipse.emf.ecore.impl.BasicEObjectImpl
org.eclipse.emf.ecore.impl.EObjectImpl
org.eclipse.m2m.atl.emftvm.trace.impl.TracedRuleImpl

All Implemented Interfaces:
  `org.eclipse.emf.common.notify.Notifier`, `org.eclipse.emf.ecore.EObject`, `org.eclipse.emf.ecore.InternalEObject`, `TracedRule`

public class TracedRuleImpl extends org.eclipse.emf.ecore.impl.EObjectImpl implements TracedRule
An implementation of the model object 'Traced Rule'.

## Nested Class Summary

## Nested classes/interfaces inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`org.eclipse.emf.ecore.impl.BasicEObjectImpl.EPropertiesHolder, org.eclipse.emf.ecore.impl.BasicEObjectImpl.EPropertiesHolderBaseImpl, org.eclipse.emf.ecore.impl.BasicEObjectImpl.EPropertiesHolderImpl`

## Nested classes/interfaces inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl

`org.eclipse.emf.common.notify.impl.BasicNotifierImpl.EAdapterList<E extends Object & org.eclipse.emf.common.notify.Adapter>, org.eclipse.emf.common.notify.impl.BasicNotifierImpl.EObservableAdapterList, org.eclipse.emf.common.notify.impl.BasicNotifierImpl.EScannableAdapterList`

## Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.InternalEObject

`org.eclipse.emf.ecore.InternalEObject.EStore`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected org.eclipse.emf.common.util.EList<TraceLink>`
`links`
The cached value of the '`Links`' containment reference list.
`protected String`
`rule`
The cached value of the '`Rule`' attribute.
`protected static final String`
`RULE_EDEFAULT`
The default value of the '`Rule`' attribute.
`protected org.eclipse.emf.common.util.EList<SourceElementList>`
`uniqueSourceElementLists`
The cached value of the '`Unique Source Element Lists`' containment reference list.
`protected org.eclipse.emf.common.util.EList<SourceElement>`
`uniqueSourceElements`
The cached value of the '`Unique Source Elements`' reference list.
`protected final Map<List<Object>,SourceElementList>`
`uniqueSourceObjectLists`
Lookup table of referred objects to `SourceElementList`s.
`protected final Map<Object,SourceElement>`
`uniqueSourceObjects`
Lookup table of referred objects to `SourceElement`s.

### Fields inherited from class org.eclipse.emf.ecore.impl.EObjectImpl

`eAdapters, eContainer, eContainerFeatureID, EDELIVER, EDYNAMIC_CLASS, eFlags, ELAST_EOBJECT_FLAG, ELAST_NOTIFIER_FLAG, eProperties, EPROXY`

### Fields inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`EVIRTUAL_GET, EVIRTUAL_IS_SET, EVIRTUAL_NO_VALUE, EVIRTUAL_SET, EVIRTUAL_UNSET`

### Fields inherited from interface org.eclipse.emf.ecore.InternalEObject

`EOPPOSITE_FEATURE_BASE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`TracedRuleImpl()`

## Method Summary

Modifier and Type
Method
Description
`org.eclipse.emf.common.notify.NotificationChain`
`basicSetLinkSet(TraceLinkSet newLinkSet, org.eclipse.emf.common.notify.NotificationChain msgs)`
`org.eclipse.emf.common.notify.NotificationChain`
`eBasicRemoveFromContainerFeature(org.eclipse.emf.common.notify.NotificationChain msgs)`
`Object`
`eGet(int featureID, boolean resolve, boolean coreType)`
`org.eclipse.emf.common.notify.NotificationChain`
`eInverseAdd(org.eclipse.emf.ecore.InternalEObject otherEnd, int featureID, org.eclipse.emf.common.notify.NotificationChain msgs)`
`org.eclipse.emf.common.notify.NotificationChain`
`eInverseRemove(org.eclipse.emf.ecore.InternalEObject otherEnd, int featureID, org.eclipse.emf.common.notify.NotificationChain msgs)`
`boolean`
`eIsSet(int featureID)`
`boolean`
`eNotificationRequired()`
`void`
`eNotify(org.eclipse.emf.common.notify.Notification notification)`
`void`
`eSet(int featureID, Object newValue)`
`protected org.eclipse.emf.ecore.EClass`
`eStaticClass()`
`void`
`eUnset(int featureID)`
`org.eclipse.emf.common.util.EList<TraceLink>`
`getLinks()`
`TraceLinkSet`
`getLinkSet()`
`String`
`getRule()`
`SourceElement`
`getUniqueSourceElement(Object sourceElement)`
`org.eclipse.emf.common.util.EList<SourceElementList>`
`getUniqueSourceElementLists()`
`org.eclipse.emf.common.util.EList<SourceElement>`
`getUniqueSourceElements()`
`SourceElementList`
`getUniqueSourceElements(List<?> sourceElements)`
`void`
`setLinkSet(TraceLinkSet newLinkSet)`
`void`
`setRule(String newRule)`
`String`
`toString()`

### Methods inherited from class org.eclipse.emf.ecore.impl.EObjectImpl

`eAdapters, eBasicAdapters, eBasicProperties, eBasicSetContainer, eClass, eContainerFeatureID, eDeliver, eInternalContainer, eInvoke, eIsProxy, eProperties, eSetClass, eSetDeliver, eSetProxyURI`

### Methods inherited from class org.eclipse.emf.ecore.impl.BasicEObjectImpl

`eAddVirtualValue, eAllContents, eBaseStructuralFeatureID, eBasicRemoveFromContainer, eBasicSetContainer, eComputeVirtualValuesCapacity, eContainer, eContainerAdapterArray, eContainingFeature, eContainmentFeature, eContainmentFeature, eContains, eContents, eCrossReferences, eDerivedOperationID, eDerivedOperationID, eDerivedStructuralFeatureID, eDerivedStructuralFeatureID, eDirectResource, eDynamicBasicRemoveFromContainer, eDynamicClass, eDynamicFeature, eDynamicFeatureID, eDynamicGet, eDynamicGet, eDynamicGet, eDynamicInverseAdd, eDynamicInverseAdd, eDynamicInverseRemove, eDynamicInverseRemove, eDynamicInvoke, eDynamicInvoke, eDynamicIsSet, eDynamicIsSet, eDynamicIsSet, eDynamicSet, eDynamicSet, eDynamicSet, eDynamicUnset, eDynamicUnset, eDynamicUnset, eGet, eGet, eGet, eHasSettings, eInternalResource, eInverseAdd, eInverseRemove, eInvocationDelegate, eInvoke, eIsSet, eObjectForURIFragmentSegment, eOpenGet, eOpenIsSet, eOpenSet, eOpenUnset, eProxyURI, eRemoveVirtualValue, eResolveProxy, eResource, eSet, eSetDirectResource, eSetResource, eSetStore, eSetting, eSettingDelegate, eSettings, eSetVirtualIndexBits, eSetVirtualValue, eSetVirtualValues, eStaticFeatureCount, eStaticOperationCount, eStore, eUnset, eURIFragmentSegment, eVirtualBitCount, eVirtualGet, eVirtualGet, eVirtualIndex, eVirtualIndexBits, eVirtualIsSet, eVirtualSet, eVirtualUnset, eVirtualValue, eVirtualValues`

### Methods inherited from class org.eclipse.emf.common.notify.impl.BasicNotifierImpl

`eBasicAdapterArray, eBasicHasAdapters`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.eclipse.emf.ecore.EObject

`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

### Methods inherited from interface org.eclipse.emf.common.notify.Notifier

`eAdapters, eDeliver, eSetDeliver`

## Field Details

### RULE_EDEFAULT

protected static final String RULE_EDEFAULT
The default value of the '`Rule`' attribute.

See Also:
  - `getRule()`

### rule

protected String rule
The cached value of the '`Rule`' attribute.

See Also:
  - `getRule()`

### links

protected org.eclipse.emf.common.util.EList<TraceLink> links
The cached value of the '`Links`' containment reference list.

See Also:
  - `getLinks()`

### uniqueSourceElements

protected org.eclipse.emf.common.util.EList<SourceElement> uniqueSourceElements
The cached value of the '`Unique Source Elements`' reference list.

See Also:
  - `getUniqueSourceElements()`

### uniqueSourceElementLists

protected org.eclipse.emf.common.util.EList<SourceElementList> uniqueSourceElementLists
The cached value of the '`Unique Source Element Lists`' containment reference list.

See Also:
  - `getUniqueSourceElementLists()`

### uniqueSourceObjects

protected final Map<Object,SourceElement> uniqueSourceObjects
Lookup table of referred objects to `SourceElement`s.

### uniqueSourceObjectLists

protected final Map<List<Object>,SourceElementList> uniqueSourceObjectLists
Lookup table of referred objects to `SourceElementList`s.

## Constructor Details

### TracedRuleImpl

protected TracedRuleImpl()

## Method Details

### eStaticClass

protected org.eclipse.emf.ecore.EClass eStaticClass()

Overrides:
  `eStaticClass` in class `org.eclipse.emf.ecore.impl.EObjectImpl`

### getRule

public String getRule()

Specified by:
  `getRule` in interface `TracedRule`
Returns:
  the value of the 'Rule' attribute.
See Also:
  - `TracedRule.setRule(String)`
  - `TracePackage.getTracedRule_Rule()`

### setRule

public void setRule(String newRule)

Specified by:
  `setRule` in interface `TracedRule`
Parameters:
  `newRule` - the new value of the 'Rule' attribute.
See Also:
  - `TracedRule.getRule()`

### getLinks

public org.eclipse.emf.common.util.EList<TraceLink> getLinks()

Specified by:
  `getLinks` in interface `TracedRule`
Returns:
  the value of the 'Links' containment reference list.
See Also:
  - `TracePackage.getTracedRule_Links()`
  - `TraceLink.getRule()`

### getLinkSet

public TraceLinkSet getLinkSet()

Specified by:
  `getLinkSet` in interface `TracedRule`
Returns:
  the value of the 'Link Set' container reference.
See Also:
  - `TracedRule.setLinkSet(TraceLinkSet)`
  - `TracePackage.getTracedRule_LinkSet()`
  - `TraceLinkSet.getRules()`

### basicSetLinkSet

public org.eclipse.emf.common.notify.NotificationChain basicSetLinkSet(TraceLinkSet newLinkSet, org.eclipse.emf.common.notify.NotificationChain msgs)

### setLinkSet

public void setLinkSet(TraceLinkSet newLinkSet)

Specified by:
  `setLinkSet` in interface `TracedRule`
Parameters:
  `newLinkSet` - the new value of the 'Link Set' container reference.
See Also:
  - `TracedRule.getLinkSet()`

### getUniqueSourceElements

public org.eclipse.emf.common.util.EList<SourceElement> getUniqueSourceElements()

Specified by:
  `getUniqueSourceElements` in interface `TracedRule`
Returns:
  the value of the 'Unique Source Elements' reference list.
See Also:
  - `TracePackage.getTracedRule_UniqueSourceElements()`
  - `SourceElement.getUniqueFor()`

### getUniqueSourceElementLists

public org.eclipse.emf.common.util.EList<SourceElementList> getUniqueSourceElementLists()

Specified by:
  `getUniqueSourceElementLists` in interface `TracedRule`
Returns:
  the value of the 'Unique Source Element Lists' containment reference list.
See Also:
  - `TracePackage.getTracedRule_UniqueSourceElementLists()`
  - `SourceElementList.getUniqueFor()`

### getUniqueSourceElement

public SourceElement getUniqueSourceElement(Object sourceElement)

Specified by:
  `getUniqueSourceElement` in interface `TracedRule`

### getUniqueSourceElements

public SourceElementList getUniqueSourceElements(List<?> sourceElements)

Specified by:
  `getUniqueSourceElements` in interface `TracedRule`

### eInverseAdd

public org.eclipse.emf.common.notify.NotificationChain eInverseAdd(org.eclipse.emf.ecore.InternalEObject otherEnd, int featureID, org.eclipse.emf.common.notify.NotificationChain msgs)

Overrides:
  `eInverseAdd` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eInverseRemove

public org.eclipse.emf.common.notify.NotificationChain eInverseRemove(org.eclipse.emf.ecore.InternalEObject otherEnd, int featureID, org.eclipse.emf.common.notify.NotificationChain msgs)

Overrides:
  `eInverseRemove` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eBasicRemoveFromContainerFeature

public org.eclipse.emf.common.notify.NotificationChain eBasicRemoveFromContainerFeature(org.eclipse.emf.common.notify.NotificationChain msgs)

Overrides:
  `eBasicRemoveFromContainerFeature` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eGet

public Object eGet(int featureID, boolean resolve, boolean coreType)

Specified by:
  `eGet` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eGet` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eSet

public void eSet(int featureID, Object newValue)

Specified by:
  `eSet` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eSet` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eUnset

public void eUnset(int featureID)

Specified by:
  `eUnset` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eUnset` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eIsSet

public boolean eIsSet(int featureID)

Specified by:
  `eIsSet` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eIsSet` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### toString

public String toString()

Overrides:
  `toString` in class `org.eclipse.emf.ecore.impl.BasicEObjectImpl`

### eNotificationRequired

public boolean eNotificationRequired()

Specified by:
  `eNotificationRequired` in interface `org.eclipse.emf.ecore.InternalEObject`
Overrides:
  `eNotificationRequired` in class `org.eclipse.emf.common.notify.impl.BasicNotifierImpl`

### eNotify

public void eNotify(org.eclipse.emf.common.notify.Notification notification)

Specified by:
  `eNotify` in interface `org.eclipse.emf.common.notify.Notifier`
Overrides:
  `eNotify` in class `org.eclipse.emf.common.notify.impl.BasicNotifierImpl`